#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class Api::ViolationsController < Api::RestController

  def index
    pid = params[:project_id]
    conditions = 'enabled=:enabled AND islast=:islast AND '
    if pid.to_i>0
      conditions += ' projects.id=:pid'
      pid=pid.to_i
    else
      conditions += ' kee=:pid'
    end
    project = Project.find(:first, :include => :snapshots, :conditions => [conditions, {:pid => pid, :enabled => true, :islast => true}])
    if project.nil?
      rest_status_ko("Project key [" + pid + "] doesn't exist", 404)
      return
    end

    snapshot = project.snapshots.first
    rules_conditions = params[:rule] ? "AND plugin_rule_key=:rule" : ""
    rule_failures = RuleFailure.find(:all,
      :conditions => [ 'rule_failures.snapshot_id=:snapshot_id ' + rules_conditions,
        {:snapshot_id => snapshot.id, :rule => params[:rule]} ],
      :include => [:rule, :rule_failure_params], :order => 'failure_level DESC')    
    rest_render(rule_failures)
  end


  private

  def rest_to_json(rule_failures)
    json = rule_failures.collect{|rule_failure| rule_failure.to_hash_json}.to_json
    json = params['callback'] + '(' + json + ');' if params['callback']
    json
  end

  def rest_to_xml(rule_failures)
    xml = Builder::XmlMarkup.new(:indent => 0)
    xml.instruct!
    xml.violations do
      rule_failures.each do |rule_failure|
        xml << rule_failure.to_xml
      end
    end
  end

end