#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#

class ChartsController < ApplicationController
  COMPLEXITY_CHART_WIDTH = 300
  COMPLEXITY_CHART_HEIGHT = 200
  COMPLEXITY_COMPARISON_CHART_WIDTH = 450
  COMPLEXITY_COMPARISON_CHART_HEIGHT = 140
  
  TREND_CHART_WIDTH = 300
  TREND_CHART_HEIGHT = 250  

  TRENDS_CHART_WIDTH = 700
  TRENDS_CHART_HEIGHT = 250   
  
  CHART_COLORS = Array[ "4192D9", "800000", "A7B307", "913C9F", "329F4D" ]
    
  def complexity_distribution_chart
    jfreechart = Sonar::Jfreechart.new()
    stream = jfreechart.complexity_chart(COMPLEXITY_CHART_WIDTH, COMPLEXITY_CHART_HEIGHT, [params[:id].to_i], Metric::CC_CLASSES_COUNT_DISTRIB)
    if stream
      send_data stream, :type => 'image/png', :disposition => 'inline'
    else 
      send_file "#{RAILS_ROOT}/public/images/nodata.png", :type => 'image/png', :disposition => 'inline'
    end
  end
  
  def complexity_distribution_comparison_chart    
    jfreechart = Sonar::Jfreechart.new()
    stream = jfreechart.complexity_chart(COMPLEXITY_COMPARISON_CHART_WIDTH, COMPLEXITY_COMPARISON_CHART_HEIGHT, params[:sid].split(',').map {|s| s.to_i}, Metric::CC_CLASSES_PERCENT_DISTRIB, '%')
    if stream
      send_data stream, :type => 'image/png', :disposition => 'inline'
    else 
      send_file "#{RAILS_ROOT}/public/images/nodata.png", :type => 'image/png', :disposition => 'inline'
    end
  end  

  def trends
    jfreechart = Sonar::Jfreechart.new()

    metric_keys=params[:metrics]
    metric_ids=[]
    if metric_keys
      metric_keys.split(',').each do |key|
        metric_ids<<Metric.by_key(key).id
      end
    end

    stream = jfreechart.trends_chart(
      TRENDS_CHART_WIDTH, TRENDS_CHART_HEIGHT, params[:id].to_i, metric_ids, params[:sids])
    send_data stream, :type => 'image/png', :disposition => 'inline' 
  end
end
