#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class ColumnsController < ApplicationController
  require_role Role::ADMIN

  before_filter :init
  
  def add
    column = @dashboard_configuration.find_available_column(@column_id)
    @dashboard_configuration.add_column(column)
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end
  
  def delete
    column = @dashboard_configuration.find_selected_column(@column_id)
    @dashboard_configuration.remove_column(column)
    if column.sort_default?
      new_sort_column = @dashboard_configuration.get_selected_columns.detect {|col| col.sortable?}
      if new_sort_column
        @dashboard_configuration.set_column_sort_default(new_sort_column.id)
      end
    end
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end

  def toggle_treemap
    @dashboard_configuration.toggle_treemap_enabled
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end
  
  def left
    column = @dashboard_configuration.find_selected_column(@column_id)
    @dashboard_configuration.move_column(column, "left")
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end
    
  def right
    column = @dashboard_configuration.find_selected_column(@column_id)
    @dashboard_configuration.move_column(column, "right")
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end  
  
  def default_sorting
    @dashboard_configuration.set_column_sort_default(@column_id)
    redirect_to :controller => 'projects', :action => 'index', :configuring => 'true'
  end  
  

  private
  
  def init
    @dashboard_configuration = Sonar::DashboardConfiguration.new(configuration)
    @column_id = params[:id]
  end


end
