 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with Sonar; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #
class Breakdown
  attr_reader :snapshot, :columns
  
  def initialize(project, metric_key, selected_snapshot_ids=[], rules_category_id=nil, rule_id=nil)
    @snapshot=Snapshot.find(:first, :conditions => {:islast => true, :project_id => project.id}, :include => 'project')
    
    @columns=[]
    @columns[0]=BreakdownColumn.new(@snapshot.id, metric_key, selected_snapshot_ids, rules_category_id, rule_id)
    
    1.upto(4) do |index|
      previous_column=@columns[index-1]
      if index==1 or (previous_column and previous_column.display_next_column?)
        @columns[index]=BreakdownColumn.new(previous_column.snapshots_for_next_column, metric_key, selected_snapshot_ids, rules_category_id, rule_id)
      end
    end
  end
  
  def full_columns
    columns.select{|column| column.display?}
  end
  
  private
  def rules_breakdown?(metric_key)
    [Metric::RULES_MANDATORY_INDEX, Metric::RULES_OPTIONAL_INDEX,Metric::RULES_MANDATORY_VIOLATIONS_COUNT, Metric::RULES_OPTIONAL_VIOLATIONS_COUNT].include? metric_key
  end
end